<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="getDataSource()" class="btn btn-default">
    <i class="fas fa-sync-alt" [ngClass]="{'fa-spin': !dataGrid}"></i>
  </button>
  <button (click)="newRow(modalHelp)" class="btn btn-primary ml-1">
    <i class="fa fa-plus mr-2"></i>Nuevo
  </button>
  <!-- <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="!dataGrid.data">
    <i class="far fa-file-pdf mr-2"></i>PDF
  </button> -->
</app-page-title>


<div class="card">
  <div class="card-body" *ngIf="!loading">

    <kendo-grid [kendoGridBinding]="dataGrid" [filter]="filter" filterable="menu" [selectable]="true" [navigable]="true"
      [reorderable]="true" [resizable]="true" [sortable]="true" [pageSize]="pageSize" [skip]="skip"
      [pageable]="{buttonCount: 5, pageSizes: [10, 25, 50]}" (edit)="editRow($event, modalHelp)"
      (remove)="deleteRow($event)" style="height: 69vh;">
      <ng-container *ngFor="let item of gridFields">
        <kendo-grid-column [field]="item.dataKey" [title]="item.title" [width]="item.width" [filterable]="item.filtro">
        </kendo-grid-column>
      </ng-container>
      <kendo-grid-column field="sfecini" title="Fecha Inicio" [width]="140" filterable="false">
        <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.sfecini | date: formatKendo }}</ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="sfecter" title="Fecha Fin" [width]="140" filterable="false">
        <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.sfecter | date: formatKendo }}</ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="Inactivo" title="Inactivo" width="130">
        <ng-template kendoGridCellTemplate let-dataItem>
          <input type="checkbox" [checked]="dataItem.Inactivo" disabled />
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-command-column title="Acciones" width="190">
        <ng-template kendoGridCellTemplate let-isNew="isNew">
          <button kendoGridEditCommand [primary]="true">Editar</button>
          <button kendoGridRemoveCommand>Eliminar</button>
        </ng-template>
      </kendo-grid-command-column>
    </kendo-grid>

  </div>
  <app-loading *ngIf="loading"></app-loading>
</div>

<ng-template #modalHelp let-modal let-c="close">
  <div class="modal-header">
    <h6 class="modal-title">
      <span *ngIf="flagEdit">Editar Suplemento</span>
      <span *ngIf="!flagEdit">Nuevo Suplemento</span>
    </h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss()">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">

    <form [formGroup]="myFormGroup">
      <div class="row d-flex justify-content-between">
        <div class="form-group col-sm-4 col-md-3 col-lg-2 col-xl-2">
          <label>Suplemento</label>
          <input type="text" class="form-control" formControlName="Suplemento" appFocus [readOnly]="flagEdit"
          maxlength="8"/>
        </div>
        <div class="k-form-field col-sm-8 col-md-5 col-lg-4 col-xl-4">
          <label>Descripción</label>
          <input type="text" class="form-control" formControlName="sdesc" maxlength="40">
        </div>
        <div class="form-group col-6 col-sm-4 col-md-4 col-lg-3 col-xl-2">
          <label>Cálculo</label>
          <kendo-dropdownlist [data]="calculos" [textField]="'title'" [valueField]="'key'" [valuePrimitive]="true"
            formControlName="scalculo" class="form-control">
          </kendo-dropdownlist>
        </div>
        <div class="form-group col-6 col-sm-4 col-md-4 col-lg-3 col-xl-2">
          <label>Aplicar Monto</label>
          <kendo-dropdownlist [data]="aplicaMonto" [textField]="'title'" [valueField]="'key'" [valuePrimitive]="true"
            formControlName="sam" class="form-control">
          </kendo-dropdownlist>
        </div>
        <div class="form-group col-6 col-sm-3 col-md-2 col-lg-2 col-xl-2">
          <label class="w-100">Porcentaje</label>
          <kendo-switch formControlName="sporc" [onLabel]="'Si'" [offLabel]="'No'"></kendo-switch>
        </div>
        <div class="form-group col-6 col-sm-3 col-md-2 col-lg-2 col-xl-2" *ngIf="myFormGroup.value.scalculo === 'F'">
          <label>Fijo</label>
          <input type="text" class="form-control" formControlName="Monto1" max="999999"/>
        </div>
        <div class="form-group col-6 col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <label>Adultos</label>
          <input type="text" class="form-control" formControlName="Monto1" max="999999"
            [readonly]="myFormGroup.value.scalculo !== 'P' && myFormGroup.value.scalculo !== 'A'" />
        </div>
        <div class="form-group col-6 col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <label>Juniors</label>
          <input type="text" class="form-control" formControlName="Monto2" max="999999"
            [readonly]="myFormGroup.value.scalculo !== 'P' && myFormGroup.value.scalculo !== 'J'" />
        </div>
        <div class="form-group col-6 col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <label>Menores</label>
          <input type="text" class="form-control" formControlName="Monto3" max="999999"
            [readonly]="myFormGroup.value.scalculo !== 'P' && myFormGroup.value.scalculo !== 'M'" />
        </div>
        <div class="form-group col-6 col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <label>P. Adicional</label>
          <input type="text" class="form-control" formControlName="Monto4" max="999999"
            [readonly]="myFormGroup.value.scalculo !== 'P' && myFormGroup.value.scalculo !== 'A'" />
        </div>
        <div class="form-group col-6 col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <label>Desde</label>
          <input type="text" class="form-control" formControlName="pe1" [readonly]="!myFormGroup.value.sporc" />
        </div>
        <div class="form-group col-6 col-sm-6 col-md-6 col-lg-3 col-xl-3">
          <label>Moneda</label>
          <kendo-dropdownlist [data]="ttMonedas" [textField]="'mdesc'" [valueField]="'Moneda'" [valuePrimitive]="true"
            formControlName="moneda" class="form-control">
          </kendo-dropdownlist>
        </div>
        <div class="form-group col-sm-4 col-md-4 col-lg-3 col-xl-3">
          <label>Aplica Tarifa</label>
          <kendo-combobox [data]="aplTarifa" [textField]="'title'" [valueField]="'key'" [valuePrimitive]="true"
            formControlName="sat" (valueChange)="aplTarValue($event)" class="form-control">
          </kendo-combobox>
        </div>
        <div class="form-group col-6 col-sm-4 col-md-4 col-lg-3 col-xl-3">
          <label class="w-100">Aplicar a tarifa sin código</label>
          <kendo-switch [onLabel]="'Si'" [offLabel]="'No'" name="chkbxAtar" [(ngModel)]="aplicaTarifa"
            [ngModelOptions]="{standalone: true}" (valueChange)="reqCod($event)"
            [attr.disabled]="myFormGroup.value.sat == 'I' ? '' : null"></kendo-switch>
        </div>
        <div class="form-group col-sm-6 col-md-4 col-lg-4 col-xl-4">
          <label>Código</label>
          <kendo-combobox [data]="ttCodigos" [textField]="'cdesc'" [valueField]="'Codigo'" [filterable]="true"
            [valuePrimitive]="true" formControlName="Codigo" [attr.disabled]="aplicaTarifa ? '' : null"
            [value]="aplicaTarifa ? '' : null" [required]="aplicaTarifa ? null : ''" class="form-control">
          </kendo-combobox>
        </div>
        <div class="form-group col-sm-4 col-md-4 col-lg-3 col-xl-3">
          <label>Venta</label>
          <kendo-combobox [data]="tVenta" [textField]="'title'" [valueField]="'key'" [valuePrimitive]="true"
            formControlName="sventa" class="form-control">
          </kendo-combobox>
        </div>

        <div class="form-group col-sm-6 col-md-8 col-lg-5 col-xl-5">
          <label>Tipo de Cuarto</label>
          <kendo-multiselect [data]="dsTcuartos" [textField]="'tcuarto'" [valueField]="'tcuarto'"
            formControlName="tcuartos" [valuePrimitive]="true" class="w-100">
          </kendo-multiselect>
        </div>


        <div class="form-group col-6 col-sm-4 col-md-4 col-lg-2 col-xl-2">
          <label>Fecha Inicio</label>
          <kendo-datepicker formControlName="sfecini" [format]="formatKendo" class="w-100"></kendo-datepicker>
        </div>
        <div class="form-group col-6 col-sm-4 col-md-4 col-lg-2 col-xl-2">
          <label>Fecha Termino</label>
          <kendo-datepicker formControlName="sfecter" [format]="formatKendo" [min]="myFormGroup.value.sfecini"
            class="w-100"></kendo-datepicker>
        </div>
        <div class="form-group col-6 col-sm-4 col-md-4 col-lg-2 col-xl-2">
          <label>Fecha Inicio Conf.</label>
          <kendo-datepicker formControlName="fic" [format]="formatKendo" class="w-100"></kendo-datepicker>
        </div>
        <div class="form-group col-6 col-sm-4 col-md-4 col-lg-2 col-xl-2">
          <label>Fecha Termino Conf.</label>
          <kendo-datepicker formControlName="ftc" [format]="formatKendo" [min]="myFormGroup.value.fic" class="w-100">
          </kendo-datepicker>
        </div>
        <div class="form-group col-6 col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <label class="w-100">Inactivo</label>
          <kendo-switch formControlName="Inactivo" [onLabel]="'Si'" [offLabel]="'No'"></kendo-switch>
        </div>
        <div class="form-group col-6 col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <label>Operador</label>
          <input type="text" class="form-control" formControlName="sope" readonly>
        </div>
      </div>

      <div class="divider"></div>

      <div class="row d-flex justify-content-around">
        <ng-container formGroupName="Dias" *ngFor="let opc of dias">
          <div class="form-group">
            <input type="checkbox" class="k-checkbox" [id]="opc.id" [name]="opc.id" [(ngModel)]="opc.value"
              formControlName="{{ opc.id }}">
            <label class="k-checkbox-label" [for]="opc.id"> {{ opc.dia }}</label>
          </div>
        </ng-container>
      </div>
    </form>

  </div>
  <div class="modal-footer">
    <button class="btn btn-success mr-1" [disabled]="myFormGroup.invalid" (click)="guardarForm()">
      <i class="fas fa-save mr-2"></i>Guardar
    </button>
    <button class="btn btn-secondary" (click)="c()">Cerrar</button>
  </div>
</ng-template>
